<script setup lang="ts">
    import { graphql } from "./../gql/index";
    import { computed, ref } from "vue";
    import { useRouter } from "vue-router";
    import useNavigationStore from "./../stores/navigation";
    import { useQuery } from "@vue/apollo-composable";
    import { VDataTable } from "vuetify/components/VDataTable";
    import { pushToClipboard } from "../functions/clipboard";
    import { DynamicRoutePaths } from "../plugins/router";

    const router = useRouter();
    const search = ref("");
    const navigationStore = useNavigationStore();

    // Instructors search query
    const instructorsSearch = graphql(`
        query InstructorsSearch {
            allInstructors {
                id
                givenName
                familyName
                callName
                telephone
            }
        }
    `);
    const { result } = useQuery(instructorsSearch, null, {
        fetchPolicy: "cache-and-network",
    });
    const instructors = computed(() => {
        const res = result.value?.allInstructors! ?? [];
        let out = [] as {
            id: string;
            callName: string;
            familyName: string;
            queryString: string;
        }[];

        res.forEach((instructor) => {
            if (instructor.callName != "REDACTED" && instructor.familyName != "REDACTED") {
                let queryString = ""; // TODO this will become possibly VERY slow if there are too many instructors in the database  -> (Not a problem for instructors I think, just copied from participants)
                queryString += instructor.givenName ?? "";
                queryString += instructor.telephone ?? "";

                out.push({
                    id: instructor.id,
                    callName: instructor.callName,
                    familyName: instructor.familyName ?? "",
                    queryString: queryString,
                });
            }
        });

        return out;
    });

    const headers = [
        {
            align: "start",
            key: "callName",
            sortable: true,
            title: "Vorname",
        },
        {
            key: "familyName",
            sortable: true,
            title: "Familienname",
        },
        {
            key: "id",
            sortable: false,
            title: "",
        },
        {
            key: "queryString",
            sortable: false,
            title: "",
        },
    ];

    function showInstructor(id: string) {
        navigationStore.instructorId = id;
        router.push({ name: DynamicRoutePaths.InstructorDetails }); // TODO move this out possibly
    }

    const tableExport = ref([] as { columns: { callName: string; id: string; familyName: string; queryString: string } }[]);
    const copyTable = function () {
        let out = "";

        tableExport.value.forEach((row) => {
            out += [row.columns.id, row.columns.callName, row.columns.familyName, row.columns.queryString].join("\t");
            out += "\n";
        });

        pushToClipboard(out);
    };
    const handleTableChange = function (currItems: any) {
        tableExport.value = currItems;
    };
</script>

<template>
    <div class="pa-3">
        <h2 class="text-center">Zirkelleiter-Suche</h2>

        <v-card title="Zirkelleiter" variant="tonal" class="my-2">
            <template v-slot:text>
                <v-text-field
                    v-model="search"
                    append-icon="mdi-magnify"
                    label="Search"
                    single-line
                    hide-details
                    class="mb-2"
                ></v-text-field>
                <v-data-table
                    :headers="(headers as any)"
                    :items="instructors"
                    :search="search"
                    multi-sort
                    @update:current-items="handleTableChange"
                >
                    <template v-slot:item.id="{ item }">
                        <v-btn size="small" @click="showInstructor(item.id)">
                            <template v-slot:prepend> <span class="material-symbols-outlined"> search </span></template>
                            Zirkelleiter anzeigen
                        </v-btn>
                    </template>
                    <template v-slot:item.queryString="{}"> </template>
                </v-data-table>
                <br />
                <v-btn @click="copyTable">
                    <template v-slot:prepend> <span class="material-symbols-outlined"> backup_table </span></template>
                    Tabelle Kopieren
                </v-btn>
            </template>
        </v-card>
    </div>
</template>
